/*
 * This file is generated by jOOQ.
 */
package com.alkemy.sophia.ripartizione.dbmodel.jooq.tables;


import com.alkemy.sophia.ripartizione.dbmodel.jooq.DefaultSchema;
import com.alkemy.sophia.ripartizione.dbmodel.jooq.Indexes;
import com.alkemy.sophia.ripartizione.dbmodel.jooq.Keys;
import com.alkemy.sophia.ripartizione.dbmodel.jooq.tables.records.InvoiceLogRecord;

import java.sql.Timestamp;
import java.util.Arrays;
import java.util.List;

import javax.annotation.Generated;

import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.Index;
import org.jooq.Name;
import org.jooq.Record;
import org.jooq.Schema;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.11.9"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class InvoiceLog extends TableImpl<InvoiceLogRecord> {

    private static final long serialVersionUID = -280629432;

    /**
     * The reference instance of <code>INVOICE_LOG</code>
     */
    public static final InvoiceLog INVOICE_LOG = new InvoiceLog();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<InvoiceLogRecord> getRecordType() {
        return InvoiceLogRecord.class;
    }

    /**
     * The column <code>INVOICE_LOG.ID_INVOICE_LOG</code>.
     */
    public final TableField<InvoiceLogRecord, Integer> ID_INVOICE_LOG = createField("ID_INVOICE_LOG", org.jooq.impl.SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>INVOICE_LOG.REQUEST_ID</code>.
     */
    public final TableField<InvoiceLogRecord, String> REQUEST_ID = createField("REQUEST_ID", org.jooq.impl.SQLDataType.VARCHAR(45).nullable(false), this, "");

    /**
     * The column <code>INVOICE_LOG.REQUEST_PARAMS</code>.
     */
    public final TableField<InvoiceLogRecord, String> REQUEST_PARAMS = createField("REQUEST_PARAMS", org.jooq.impl.SQLDataType.CLOB.nullable(false), this, "");

    /**
     * The column <code>INVOICE_LOG.RESPONSE_PARAMS</code>.
     */
    public final TableField<InvoiceLogRecord, String> RESPONSE_PARAMS = createField("RESPONSE_PARAMS", org.jooq.impl.SQLDataType.CLOB, this, "");

    /**
     * The column <code>INVOICE_LOG.START_DATE</code>.
     */
    public final TableField<InvoiceLogRecord, Timestamp> START_DATE = createField("START_DATE", org.jooq.impl.SQLDataType.TIMESTAMP.nullable(false), this, "");

    /**
     * The column <code>INVOICE_LOG.DURATION</code>.
     */
    public final TableField<InvoiceLogRecord, Long> DURATION = createField("DURATION", org.jooq.impl.SQLDataType.BIGINT, this, "");

    /**
     * The column <code>INVOICE_LOG.ID_INVOICE</code>.
     */
    public final TableField<InvoiceLogRecord, Integer> ID_INVOICE = createField("ID_INVOICE", org.jooq.impl.SQLDataType.INTEGER.nullable(false), this, "");

    /**
     * Create a <code>INVOICE_LOG</code> table reference
     */
    public InvoiceLog() {
        this(DSL.name("INVOICE_LOG"), null);
    }

    /**
     * Create an aliased <code>INVOICE_LOG</code> table reference
     */
    public InvoiceLog(String alias) {
        this(DSL.name(alias), INVOICE_LOG);
    }

    /**
     * Create an aliased <code>INVOICE_LOG</code> table reference
     */
    public InvoiceLog(Name alias) {
        this(alias, INVOICE_LOG);
    }

    private InvoiceLog(Name alias, Table<InvoiceLogRecord> aliased) {
        this(alias, aliased, null);
    }

    private InvoiceLog(Name alias, Table<InvoiceLogRecord> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, DSL.comment(""));
    }

    public <O extends Record> InvoiceLog(Table<O> child, ForeignKey<O, InvoiceLogRecord> key) {
        super(child, key, INVOICE_LOG);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Schema getSchema() {
        return DefaultSchema.DEFAULT_SCHEMA;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<Index> getIndexes() {
        return Arrays.<Index>asList(Indexes.INVOICE_LOG_FK_INVOICE_LOG_01, Indexes.INVOICE_LOG_INVOICE_LOG_UNIQUE_01, Indexes.INVOICE_LOG_PRIMARY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Identity<InvoiceLogRecord, Integer> getIdentity() {
        return Keys.IDENTITY_INVOICE_LOG;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public UniqueKey<InvoiceLogRecord> getPrimaryKey() {
        return Keys.KEY_INVOICE_LOG_PRIMARY;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<UniqueKey<InvoiceLogRecord>> getKeys() {
        return Arrays.<UniqueKey<InvoiceLogRecord>>asList(Keys.KEY_INVOICE_LOG_PRIMARY, Keys.KEY_INVOICE_LOG_INVOICE_LOG_UNIQUE_01);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public InvoiceLog as(String alias) {
        return new InvoiceLog(DSL.name(alias), this);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public InvoiceLog as(Name alias) {
        return new InvoiceLog(alias, this);
    }

    /**
     * Rename this table
     */
    @Override
    public InvoiceLog rename(String name) {
        return new InvoiceLog(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public InvoiceLog rename(Name name) {
        return new InvoiceLog(name, null);
    }
}
